package webspin.projects.client;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.ui.Button;

/**
 * Custom button to add rows
 * 
 * @author Maarten Bogaert
 *
 */
public class AddRowButton extends Button {
	HandlerManager eventBus;
	
	/**
	 * Constructor 
	 * 
	 * @param text
	 * @param eventBus
	 */
	public AddRowButton(String text, HandlerManager eventBus)
	{
		// calls GWT Button
		super(text);
		this.eventBus = eventBus;
		initialize();
	}
	
	/**
	 * Adds Click Handler: when clicked, a TableRowEvent is sent to the eventBus (and fired)
	 */
	private void initialize()
	{
		this.addClickHandler(new ClickHandler(){
			public void onClick(ClickEvent event) {
				// creates a new event, if desired additional data can be sent
				TableRowEvent sent = new TableRowEvent();
				eventBus.fireEvent(sent);
			}		
		});
	}
}
