package webspin.projects.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.VerticalPanel;


/**
 * The class is nothing more than a button sending an event, and a table adding a row when the event fires. 
 * All communication is done with the eventBus.
 */
public class EventTester implements EntryPoint {
	// just a container
	private VerticalPanel mainPanel = new VerticalPanel();
	
	/* (non-Javadoc)
	 * @see com.google.gwt.core.client.EntryPoint#onModuleLoad()
	 * 
	 * no special code here
	 */
	public void onModuleLoad() {
		// defines the eventBus
		HandlerManager eventBus = new HandlerManager(null);
		
		// creates the add Row button
		AddRowButton addRowButton = new AddRowButton("send", eventBus);
		
		// creates the specific table
		SpecialTable mainTable = new SpecialTable(eventBus);
		
		// adds both to panel and to root
		mainPanel.add(addRowButton);
		mainPanel.add(mainTable);
		RootPanel.get("eventTestDiv").add(mainPanel);
	}
}
