package webspin.projects.client;

import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.Label;

public class SpecialTable extends FlexTable {
	
	// local reference to the eventBus
	HandlerManager eventBus;
	
	
	/**
	 * Constructor
	 * 
	 * @param eventBus
	 */
	public SpecialTable(HandlerManager eventBus)
	{
		this.eventBus = eventBus;
		
		// start listening to the event bus
		this.listenToAddRowEvent();
	}
	
	
	/**
	 * Adds a row and a label in its first cell
	 */
	public void addSpecialRow()
	{
		this.setWidget(this.getRowCount(), 0 ,new Label("special row "+ this.getRowCount() + "!"));
	}

	/**
	 * Registers a new Table Row Event handler to the eventbus. Whenever the eventBus fires a TableRowEvent,
	 * the handler will call on addSpecialRow 
	 */
	private void listenToAddRowEvent()
	{
		// registering the table to the eventBus
		eventBus.addHandler(TableRowEvent.TYPE, new TableRowEventHandler(){
			public void onAddRow(TableRowEvent event) {
				// do something
				addSpecialRow();
			}
		});
	}
}
